-----------------------------------------------------------------------------------------------
-- Client Lua Script for SCastBar
-- All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"

-----------------------------------------------------------------------------------------------
-- SCastBar Module Definition
-----------------------------------------------------------------------------------------------
local SCastBar = {} 
local defaultSettings = {
	version = "1.3.1",
	bNewSaveData = false,
	playerBar = {
		left = -202,
		top = 385,
		right = 202,
		bottom = 416,
		clrBarColor = "ff0d75f8",
		clrTextColor = "ffffffff",
		sTexture = "SCastBarTextures:Minimalist",
		bShowIcon = true,
		bEnabled = true,
		bCastTime = true,
		bCCArmor = true,
		bLatency = false,
		bColorByHostility = false
	},
	specialBar = {
		left = -202,
		top = 215,
		right = 202,
		bottom = 246,
		clrBarColor = "ff0d75f8",
		clrTextColor = "ffffffff",
		sTexture = "SCastBarTextures:Minimalist",
		bShowIcon = false,
		bEnabled = true,
		bCastTime = true,
		bCCArmor = false,
		bLatency = false,
		bColorByHostility = true
	},
	targetBar = {
		left = 206,
		top = 385,
		right = 408,
		bottom = 416,
		clrBarColor = "ffe50000",
		clrTextColor = "ffffffff",
		sTexture = "SCastBarTextures:Minimalist",
		bShowIcon = false,
		bEnabled = true,
		bCastTime = true,
		bCCArmor = true,
		bLatency = false,
		bColorByHostility = true
	},
	targetTargetBar = {		
		left = 206,
		top = 420,
		right = 408,
		bottom = 451,
		clrBarColor = "ffe50000",
		clrTextColor = "ffffffff",
		sTexture = "SCastBarTextures:Minimalist",
		bShowIcon = false,
		bEnabled = false,
		bCastTime = true,
		bCCArmor = false,
		bLatency = false,
		bColorByHostility = true
	},
	focusBar = {
		left = -408,
		top = 385,
		right = -206,
		bottom = 416,
		clrBarColor = "ff06b1c4",
		clrTextColor = "ffffffff",
		sTexture = "SCastBarTextures:Minimalist",
		bShowIcon = false,
		bEnabled = true,
		bCastTime = true,
		bCCArmor = true,
		bLatency = false,
		bColorByHostility = true
	},
	focusTargetBar = {
		left = -408,
		top = 420,
		right = -206,
		bottom = 451,
		clrBarColor = "ff06b1c4",
		clrTextColor = "ffffffff",
		sTexture = "SCastBarTextures:Minimalist",
		bShowIcon = false,
		bEnabled = false,
		bCastTime = true,
		bCCArmor = false,
		bLatency = false,
		bColorByHostility = true
	},
	clusterBarContainer = {
		left = 513,
		top = 261,
		right = 614,
		bottom = 416,
		clrBarColor = "ff840000",
		clrTextColor = "ffffffff",
		sTexture = "SCastBarTextures:Minimalist",
		bShowIcon = false,
		bEnabled = flase,
		bCastTime = false,
		bCCArmor = false,
		bLatency = false,
		bColorByHostility = true,
		bGrowUpwards = true
	},
	clusterBar = {
		left = 0,
		top = 0,
		right = 101,
		bottom = 31,
		clrBarColor = "ff840000",
		clrTextColor = "ffffffff",
		sTexture = "SCastBarTextures:Minimalist",
		bShowIcon = false,
		bEnabled = false,
		bCastTime = true,
		bCCArmor = false,
		bLatency = false,
		bColorByHostility = true

	},
	tColors = {
		[0] = "ffe50000", --hostile
		[1] = "ffffff14",-- Neutral
		[2] = "ff15b01a"-- friendly
	},
	bLocked = false,
	bEditMode = false
}

SCastBar.arProfiles = {}
SCastBar.tRealmCharacter = {}
SCastBar.curProfile = "Default"
SCastBar.curLatency = 0
	-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function SCastBar:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function SCastBar:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, true)
	
end
 

-----------------------------------------------------------------------------------------------
-- SCastBar OnLoad
-----------------------------------------------------------------------------------------------
function SCastBar:OnLoad()
	--[[if self.Settings == nil then
		self.Settings = self:CopyTable(defaultSettings)
		Print("No Settings- > Default")
	end]]
	
    -- load our form file
	
	
	-- Spell Threshold events
	
	
		
	
	self.tCurrentOpSpell = nil
	self.tCurrentOpSpellTap = nil
	self.tDividers = nil
	self.oCurSpellIcon = nil
	self.bCharacterCreated = false
	self.bRestored = false


	if GameLib.GetPlayerUnit() then
		self:OnCharacterCreated()
	else
		Apollo.RegisterEventHandler("CharacterCreated", "OnCharacterCreated", self)
	end
	

end


function SCastBar:OnConfigure()
	--self.SettingsOld = self:CopyTable(self.Settings)
	--local profileOld = self.curProfile
	--self.ProfileOld = profileOld
	self.wndConfig:Show(true) -- show the window
end

-----------------------------------------------------------------------------------------------
-- SCastBar OnDocLoaded
-----------------------------------------------------------------------------------------------
function SCastBar:OnDocLoaded()


	
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then


		if self.Settings == nil then
			self.Settings = self:CopyTable(defaultSettings)
		end
		if SCastBar.arProfiles.Default == nil then
			SCastBar.arProfiles.Default = SCastBar:CopyTable(defaultSettings)
		end
		if self.curProfile == nil then
			self.curProfile 	= "Default"
		end
		
		Apollo.RegisterEventHandler("StartSpellThreshold", 	"OnStartSpellThreshold", self)
		Apollo.RegisterEventHandler("ClearSpellThreshold", 	"OnClearSpellThreshold", self)
		Apollo.RegisterEventHandler("UpdateSpellThreshold", "OnUpdateSpellThreshold", self)
	

		--Apollo.RegisterEventHandler("Tutorial_RequestUIAnchor", 	"OnTutorial_RequestUIAnchor", self)
		
		Apollo.RegisterTimerHandler("UpdateSCastBarTimer", 	"OnUpdate", self)
		Apollo.RegisterTimerHandler("ClearDividerTimer", "OnClearDivider", self)
		--Apollo.LoadSprites("Textures.xml", "SCastBarSprites")
		
		self.wndCastFrame 		= Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", "InWorldHudStratum", self)
		
		self.wndSpecialCastFrame = Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", "InWorldHudStratum", self)

		
		
		

		self.wndConfig = Apollo.LoadForm(self.xmlDoc, "SCastBarConfig", nil, self)
		if self.wndConfig == nil then
			Apollo.AddAddonErrorText(self, "Could not load the Config for some reason.")
			return
		end
		self.wndConfig:Show(false, true)
		self.wndSettings_Profiles  = Apollo.LoadForm(self.xmlDoc, "Settings_Profiles", self.wndConfig:FindChild("SettingsFrame"), self)
		self.wndSettings_Profiles:Show(true, false)
		self.wndSettings_Player  = Apollo.LoadForm(self.xmlDoc, "Settings_Player", self.wndConfig:FindChild("SettingsFrame"), self)
		self.wndSettings_Player:Show(false, false)
		self.wndSettings_Target = Apollo.LoadForm(self.xmlDoc, "Settings_Target", self.wndConfig:FindChild("SettingsFrame"), self)
		self.wndSettings_Target:Show(false, false)
		self.wndSettings_Focus  = Apollo.LoadForm(self.xmlDoc, "Settings_Focus", self.wndConfig:FindChild("SettingsFrame"), self)
		self.wndSettings_Focus:Show(false, false)
		self.wndSettings_Cluster  = Apollo.LoadForm(self.xmlDoc, "Settings_Cluster", self.wndConfig:FindChild("SettingsFrame"), self)
		self.wndSettings_Cluster:Show(false, false)
		

		
		
		self.wndTargetCastFrame = Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", "InWorldHudStratum", self)		
		self.wndTargetTargetCastFrame = Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", "InWorldHudStratum", self)
		self.wndFocusCastFrame = Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", "InWorldHudStratum", self)
		self.wndFocusTargetCastFrame = Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", "InWorldHudStratum", self)

		self.wndClusterContainer = Apollo.LoadForm(self.xmlDoc, "SCastBarClusterContainer", "InWorldHudStratum", self)
		self.wndClusterBar1 = Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", self.wndClusterContainer, self)
		self.wndClusterBar2 = Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", self.wndClusterContainer, self)
		self.wndClusterBar3 = Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", self.wndClusterContainer, self)
		self.wndClusterBar4 = Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", self.wndClusterContainer, self)
		self.wndClusterBar5 = Apollo.LoadForm(self.xmlDoc, "SCastBarContainer", self.wndClusterContainer, self)
		for i = 1, 5 do
			self["wndClusterBar"..i]:SetAnchorPoints(0, (i-1)*0.2, 1, i*0.2)
			self["wndClusterBar"..i]:SetAnchorOffsets(0, 0, 0,0 )
			self["wndClusterBar"..i]:Show(false,true)

		end
		
		self.wndClusterContainer:FindChild("Backdrop"):SetOpacity(0.5)
		
		self:ApplySettingsAll()
	-- Do additional Addon initialization here
	
		local tf = Apollo.GetAddon("TargetFrame")
		if tf == nil then
			tf = Apollo.GetAddon("FastTargetFrame")
		end
		if tf ~= nil then
			if tf.xmlDoc ~= nil then --and not tf.xmlDoc:IsLoaded() then
				local oldReady = tf.OnDocumentReady
				tf.OnDocumentReady = function(self)
					oldReady(self)
					self.luaUnitFrame.UpdateCastingBar = function(self, wndFrame, unitCaster) wndFrame:FindChild("CastingFrame"):Show(false) end 
					self.luaTargetFrame.UpdateCastingBar = function(self, wndFrame, unitCaster) wndFrame:FindChild("CastingFrame"):Show(false) end 
					self.luaFocusFrame.UpdateCastingBar = function(self, wndFrame, unitCaster) wndFrame:FindChild("CastingFrame"):Show(false) end 
				end
			--[[elseif tf.xmlDoc ~= nil then
		
				tf.luaUnitFrame.UpdateCastingBar = function(self, wndFrame, unitCaster) wndFrame:FindChild("CastingFrame"):Show(false) end 
				tf.luaTargetFrame.UpdateCastingBar = function(self, wndFrame, unitCaster) wndFrame:FindChild("CastingFrame"):Show(false) end 
				tf.luaFocusFrame.UpdateCastingBar = function(self, wndFrame, unitCaster) wndFrame:FindChild("CastingFrame"):Show(false) end ]]
			end
		end
	end
end

function SCastBar:OnCharacterCreated()

	local unitPlayer = GameLib.GetPlayerUnit()
	if unitPlayer == nil or self.bCharacterCreated then
		return
	end
	self.bCharacterCreated = true
	if self.bRestored then
	  	self:LoadProfile()
		SCastBar.Settings = self:CopyTable(self.arProfiles[self.curProfile])
	end

	
	self.xmlDoc = XmlDoc.CreateFromFile("SCastBar.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	Apollo.CreateTimer("UpdateSCastBarTimer", 0.033, true)
	Apollo.StartTimer("UpdateSCastBarTimer")
	Apollo.CreateTimer("ClearDividerTimer", 8, false)
	Apollo.StopTimer("ClearDividerTimer")
	Apollo.RegisterSlashCommand("scast", "OnSCastBarOn", self)
	
	
end

function SCastBar:OnUpdate()
	local unitPlayer = GameLib.GetPlayerUnit()
	if not unitPlayer then	return	end

	if self.Settings == nil then
		return
		--self.Settings = self:CopyTable(defaultSettings)
	end 
	
	self.curLatency = GameLib.GetLatency()
	
	local bIsTapping = false
	local myOpSpell = nil
	
	if self.Settings.bEditMode then
		self.wndCastFrame:Show(true)

	else
		if self.tCurrentOpSpell ~= nil then
			myOpSpell = self.tCurrentOpSpell
		elseif self.tCurrentOpSpellTap ~= nil then
			myOpSpell = self.tCurrentOpSpellTap
		end
		if myOpSpell ~= nil then
			if myOpSpell.eCastMethod == Spell.CodeEnumCastMethod.RapidTap then
	
				bIsTapping = true
			elseif myOpSpell.eCastMethod == Spell.CodeEnumCastMethod.PressHold then
				
				self:DrawSingleBarFrameTiered(self.wndCastFrame)
			elseif myOpSpell.eCastMethod == Spell.CodeEnumCastMethod.ChargeRelease then
				self:DrawSingleBarFrameTiered(self.wndCastFrame)
			end
		end
		
		
		-- Casting Bar Update
		local bShowCasting = false
		local fDuration = 0
		local fElapsed = 0
		local strSpellName = "SpellName"
		local nElapsed = 0
		local eType = Unit.CodeEnumCastBarType.None
		local strCastTime = "0.0"
		local fTimeRemaining = 0
		local fBarMax = 1
		local fBarCur = 0
		local bIsFullyCharged = false
	
		
		
		
	
		
		if unitPlayer:IsCasting() or (bIsTapping and not self.Settings.specialBar.bEnabled) then
			self.bIsShown = true
			--eType = unitPlayer:GetCastBarType(self.wndCastFrame)
	
			bShowCasting = true
			fDuration = unitPlayer:GetCastDuration()
			strSpellName = unitPlayer:GetCastName()
			
			
			
			if fDuration > 0 then
				fElapsed = unitPlayer:GetCastElapsed()
				fTimeRemaining = (fDuration - fElapsed)/1000
				strCastTime = string.format("%.1fs", fTimeRemaining)
				fBarMax = fDuration
				fBarCur = fElapsed
	
			elseif myOpSpell ~= nil then
				if myOpSpell.eCastMethod == Spell.CodeEnumCastMethod.PressHold or myOpSpell.eCastMethod == Spell.CodeEnumCastMethod.ChargeRelease then
					local fPercentDone = GameLib.GetSpellThresholdTimePrcntDone(myOpSpell.id)
					fBarMax = 1 * (myOpSpell.nMaxTier  - 1)
					fBarCur = fPercentDone + myOpSpell.nCurrentTier - 1
					strSpellName = myOpSpell.strName-- .. " -("..self.tCurrentOpSpell.nCurrentTier.."/"..self.tCurrentOpSpell.nMaxTier..")"
	
		
					if myOpSpell.nCurrentTier == myOpSpell.nMaxTier then
						strCastTime = "0.0s"
						bIsFullyCharged = true
					else 
				 		fElapsed = (myOpSpell.nCurrentTier + fPercentDone) * (myOpSpell.fDuration/myOpSpell.nMaxTier)
						
						strCastTime = string.format("%.1fs", myOpSpell.fDuration - fElapsed)
					end
				end
				
			end
			
			
			
			if bIsTapping and not self.Settings.specialBar.bEnabled then
				
				fPercentDone = GameLib.GetSpellThresholdTimePrcntDone(myOpSpell.id)
				fTapBarMax = 1 
				fTapBarCur = 1- fPercentDone 
				strSpellName = myOpSpell.strName
				self.wndCastFrame:FindChild("TapBar"):SetMax(fTapBarMax)
				self.wndCastFrame:FindChild("TapBar"):SetProgress(fTapBarCur)
			end 
			
			
		else
			self.bIsShown = false
			self.wndCastFrame:Show(false)
			self.oCurSpellIcon = nil
		end
		
		
					
		--if ((bShowCasting  and nMaxZone > 0) or self.Settings.bEditMode) and self.Settings.playerBar.bEnabled then
		if self.Settings.playerBar.bEnabled and bShowCasting then
			self.wndCastFrame:Show(true)--bShowCasting or self.Settings.bEditMode)
			if self.Settings.playerBar.bShowIcon and (self.oCurSpellIcon == nil and strSpellName ~= "SpellName" and strSpellName ~= "") then
				self.oCurSpellIcon = self:GetSpellIconByName(strSpellName)
	
			end
	
			self.wndCastFrame:FindChild("CastBar"):SetMax(fBarMax)
			self.wndCastFrame:FindChild("CastBar"):SetProgress(fBarCur)
			
			if self.Settings.playerBar.bLatency then			
				self.wndCastFrame:FindChild("CastBar"):FindChild("Latency"):SetMax(fBarMax)
				self.wndCastFrame:FindChild("CastBar"):FindChild("Latency"):SetProgress(self.curLatency)
				self.wndCastFrame:FindChild("CastBar"):FindChild("Latency"):SetOpacity(0.8)
			end
			
			self.wndCastFrame:FindChild("CastBar"):FindChild("SpellName"):SetText(strSpellName)
			
			if not self.Settings.playerBar.bCastTime then
				strCastTime = ""
			end
			self.wndCastFrame:FindChild("CastBar"):FindChild("CastTime"):SetText(strCastTime)
			
			if self.Settings.playerBar.bShowIcon and self.oCurSpellIcon ~= nil and self.oCurSpellIcon ~= "" then
				self.wndCastFrame:FindChild("SpellIcon"):SetSprite(self.oCurSpellIcon)
				self:HideCastIcons(self.wndCastFrame,"SpellIcon",false)
			else
				self:HideCastIcons(self.wndCastFrame,"SpellIcon",true)
			end
			
			-- Fullycharged -> surged zeigen
			if bIsFullyCharged then
				self.wndCastFrame:FindChild("Surged"):Show(true)
				self.wndCastFrame:FindChild("Surged2"):Show(true)
				--self.wndCastFrame:FindChild("Surged"):SetOpacity(0.8)
			--	self.wndCastFrame:FindChild("Surged2"):SetOpacity(0.3)
			else
				self.wndCastFrame:FindChild("Surged"):Show(false)
				self.wndCastFrame:FindChild("Surged2"):Show(false)
			
			end
		end
	end
	
	
	
	
	-- Update all other bars
	local targetUnit = unitPlayer:GetTarget()
	
	if self.Settings.targetBar.bEnabled  and targetUnit ~= nil then
		self:UpdateCastingBar(self.wndTargetCastFrame, targetUnit, "target")
	else
		self.wndTargetCastFrame:Show(self.Settings.bEditMode and self.Settings.targetBar.bEnabled,true)
	end

	local ToTUnit = nil
	local tCluster = nil
	if targetUnit ~= nil then
		ToTUnit = targetUnit:GetTarget()
		tCluster = targetUnit:GetClusterUnits()
	end
	if self.Settings.targetTargetBar.bEnabled  and ToTUnit ~= nil then
		self:UpdateCastingBar(self.wndTargetTargetCastFrame, ToTUnit, "targetTarget")
	else
		self.wndTargetTargetCastFrame:Show(self.Settings.bEditMode and self.Settings.targetTargetBar.bEnabled ,true)
	end
	
	if self.Settings.clusterBar.bEnabled  and tCluster ~= nil and not self.Settings.bEditMode then
		
		self:UpdateCluster(tCluster)
	else
		local bShow = self.Settings.bEditMode and self.Settings.clusterBar.bEnabled
		self.wndClusterContainer:Show(bShow , true)
		if bShow then
			for idx = 1, 5 do
				local wndFrame = self["wndClusterBar"..idx]
				wndFrame:Show(true)
				wndFrame:FindChild("CastBar"):FindChild("SpellName"):SetText("Cluster"..idx)
		
			end
		end
	end
	
	
	
	
	
	local focusUnit = unitPlayer:GetAlternateTarget()
	if self.Settings.focusBar.bEnabled  and focusUnit ~= nil then
		self:UpdateCastingBar(self.wndFocusCastFrame, focusUnit, "focus")
	else
		self.wndFocusCastFrame:Show(self.Settings.bEditMode and self.Settings.focusBar.bEnabled,true)
	end
	
	local focusTargetUnit = nil
	if focusUnit ~= nil then
		focusTargetUnit = focusUnit:GetTarget()
	end
	if self.Settings.focusTargetBar.bEnabled  and focusTargetUnit ~= nil then
		self:UpdateCastingBar(self.wndFocusTargetCastFrame, focusTargetUnit, "focusTarget")
	else
		self.wndFocusTargetCastFrame:Show(self.Settings.bEditMode and self.Settings.focusTargetBar.bEnabled ,true)
	end
	
	
	if self.Settings.specialBar.bEnabled and ( bIsTapping or self.tCurrentOpSpellTap ~= nil) then
		self:UpdateSpecialCastingBar()
	else
		self.wndSpecialCastFrame:Show(self.Settings.bEditMode and self.Settings.specialBar.bEnabled,true)
	
	end

end

function SCastBar:UpdateCluster(tCluster)
	
	local unitPlayer = GameLib.GetPlayerUnit()
	
	-- hide cluster if target dead or nil
	if unitPlayer:GetTarget() == nil or unitPlayer:GetTarget():IsDead() then
		self.wndClusterContainer:Show(false)
		return
	end
	
	local nOffset = 0
	for idx = 1, #tCluster do
		if idx - nOffset > 5 then
			return
		end
		local wndFrame = self["wndClusterBar"..idx - nOffset]
		if tCluster[idx] == unitPlayer:GetTarget() then
			wndFrame:Show(false)
			nOffset = nOffset + 1
		else
			self:UpdateCastingBar(wndFrame, tCluster[idx], "cluster")
		end

	end
	if #tCluster <	5 then
		for idx = #tCluster+1-nOffset, 5 do
			local wndFrame = self["wndClusterBar"..idx]

			wndFrame:Show(false)
			

		end
	end
	self.wndClusterContainer:Show(true)
	
end


function SCastBar:UpdateCastingBar(wndFrame, unitCaster, sBar)
	if not self.Settings.bEditMode then
		if unitCaster == nil then
			wndFrame:Show(false)
			return
		end
	
		local bShowCasting = false
		
		--local nMaxZone = 0
		local nDuration = 0
		local nElapsed = 0
		local strSpellName = ""
		local nElapsed = 0
		local eType = Unit.CodeEnumCastBarType.None
		local strIcon = ""
		local fTimeRemaining = nil
		local strCastTime = ""
		local nCCArmorValue = 0 
		local nCCArmorMax = 0
	
		
		local eDisposition = 1
	
		local wndCastProgress = wndFrame:FindChild("CastBar")
		local wndCastName = wndFrame:FindChild("CastBar"):FindChild("SpellName")
		local wndCastTime = wndFrame:FindChild("CastBar"):FindChild("CastTime")
	
	
		if unitCaster ~= nil and unitCaster:ShouldShowCastBar() then
			eType = unitCaster:GetCastBarType()
			eDisposition = unitCaster:GetDispositionTo(GameLib.GetPlayerUnit())
	
			nCCArmorValue = unitCaster:GetInterruptArmorValue()
			nCCArmorMax = unitCaster:GetInterruptArmorMax()
	
	
			if eType ~= Unit.CodeEnumCastBarType.None then
	
				bShowCasting = true

				nDuration = unitCaster:GetCastDuration()
				nElapsed = unitCaster:GetCastElapsed()
				
				fTimeRemaining = (nDuration - nElapsed)/1000
				strCastTime = string.format("%.1fs", fTimeRemaining)
				fBarMax = fDuration
				fBarCur = fElapsed
	
				strSpellName = unitCaster:GetCastName()
			end
		end
		wndFrame:Show(bShowCasting)
		if wndCastProgress ~= nil then
			wndFrame:Show(bShowCasting)
		end

		if bShowCasting and nDuration > 0 then	
	
			if wndCastProgress ~= nil then
				wndCastProgress:Show(bShowCasting)
				wndCastProgress:SetMax(nDuration)
				wndCastProgress:SetProgress(nElapsed)
				if self.Settings[sBar.."Bar"].bColorByHostility then
					wndCastProgress:SetBarColor(self.Settings.tColors[eDisposition])
				end
				if self.Settings[sBar.."Bar"].bCCArmor and nCCArmorMax ~= 0 then
					self:HideCastIcons(wndFrame, "InterruptIcon" ,false)
					
					if nCCArmorMax == -1 then
						wndFrame:FindChild("InterruptIcon"):SetSprite("CRB_ActionBarSprites:sprAb_IntArm_Invulnerable")
					elseif nCCArmorValue == 0 and nCCArmorMax > 0 then
						wndFrame:FindChild("InterruptIcon"):SetText("")
						wndFrame:FindChild("InterruptIcon"):SetSprite("CRB_ActionBarSprites:sprAb_IntArm_Broken")
					elseif nCCArmorMax > 0 then
						wndFrame:FindChild("InterruptIcon"):SetText(nCCArmorValue)
						wndFrame:FindChild("InterruptIcon"):SetSprite("CRB_ActionBarSprites:sprAb_IntArm_Regular")
					end
				else
					self:HideCastIcons(wndFrame,"InterruptIcon", true)
					
				end
	
				
				wndCastName:SetText(strSpellName)

				if not self.Settings[sBar.."Bar"].bCastTime then
					strCastTime = ""
				end
				wndCastTime:SetText(strCastTime)
				
				if self.Settings[sBar.."Bar"].bLatency then
						
					wndCastProgress:FindChild("Latency"):SetMax(fBarMax)
					wndCastProgress:FindChild("Latency"):SetProgress(self.curLatency)
					wndCastProgress:FindChild("Latency"):SetOpacity(0.8)
					--else 
				
				end
				
			end
			
		end
	end
end


function SCastBar:UpdateSpecialCastingBar()
	if not self.Settings.bEditMode then

		local unitPlayer = GameLib.GetPlayerUnit()
		
		local bIsTapping = false
		
	
		local myOpSpell = nil
		if self.tCurrentOpSpellTap ~= nil then
			myOpSpell = self.tCurrentOpSpellTap
			bIsTapping = true
		end
	
	
	
		local bShowCasting = false
		local strSpellName = "SpellName"
		local strCastTime = ""
	
		
	
		if bIsTapping  then
			bShowCasting = true
	
			fPercentDone = GameLib.GetSpellThresholdTimePrcntDone(myOpSpell.id)
			
			fTapBarMax = 1 
			fTapBarCur = 1- fPercentDone 
			strSpellName = myOpSpell.strName
			self.wndSpecialCastFrame:FindChild("TapBar"):SetMax(fTapBarMax)
			self.wndSpecialCastFrame:FindChild("TapBar"):SetProgress(fTapBarCur)
			
	
	
			strCastTime = myOpSpell.nMaxTier-myOpSpell.nCurrentTier.."/"..myOpSpell.nMaxTier
	
			
		else
			
			bShowCasting = false
			self.wndSpecialCastFrame:Show(false)
		end
		
		
					
		if bShowCasting then
			self.wndSpecialCastFrame:Show(true)--bShowCasting or self.Settings.bEditMode)
			if self.Settings.specialBar.bShowIcon and (self.CurTapSpellIcon == nil and strSpellName ~= "SpellName" and strSpellName ~= "") then
				self.CurTapSpellIcon = self:GetSpellIconByName(strSpellName)
	
			end
			self.wndSpecialCastFrame:FindChild("CastBar"):SetMax(1)--fBarMax)
			self.wndSpecialCastFrame:FindChild("CastBar"):SetProgress(0)--fBarCur)
			
			
			
			self.wndSpecialCastFrame:FindChild("CastBar"):FindChild("SpellName"):SetText(strSpellName)
			
			
			if not self.Settings.specialBar.bCastTime then
				strCastTime = ""
			end
			self.wndSpecialCastFrame:FindChild("CastBar"):FindChild("CastTime"):SetText(strCastTime)
			
			if self.Settings.specialBar.bShowIcon and self.CurTapSpellIcon ~= nil and self.CurTapSpellIcon ~= "" then
				self.wndSpecialCastFrame:FindChild("SpellIcon"):SetSprite(self.CurTapSpellIcon)
				self:HideCastIcons(self.wndSpecialCastFrame,"SpellIcon",false)
			else
				self:HideCastIcons(self.wndSpecialCastFrame,"SpellIcon",true)
			end
			
	
	
		end
	end


end










function SCastBar:OnStartSpellThreshold(idSpell, nMaxThresholds, eCastMethod) -- also fires on tier change
	if self.tCurrentOpSpell ~= nil and idSpell == self.tCurrentOpSpell.id then return end -- we're getting an update event, ignore this one

	self.tCurrentOpSpell = {}
	local splObject = GameLib.GetSpell(idSpell)
	
	self.tCurrentOpSpell.id = idSpell
	self.tCurrentOpSpell.nCurrentTier = 1
	self.tCurrentOpSpell.nMaxTier = nMaxThresholds
	self.tCurrentOpSpell.eCastMethod = eCastMethod
	self.tCurrentOpSpell.strName = splObject:GetName()
	self.tCurrentOpSpell.fDuration = splObject:GetThresholdTime()

	
	
	if self.tCurrentOpSpell.eCastMethod == Spell.CodeEnumCastMethod.PressHold or self.tCurrentOpSpell.eCastMethod == Spell.CodeEnumCastMethod.ChargeRelease then
		local nLeft = 0
		local nRight = 1
		local nMax = (self.tCurrentOpSpell.nMaxTier - 1)
		if self.tDividers ~= nil then
			for i, wnd in pairs(self.tDividers) do
				self.tDividers[i]:Destroy()
			end
			self.tDividers = nil
		end
		
		
		
		self.tDividers = {}
		for i = 1, nMax do
			nLeft = (i-1)/nMax
			nRight = i/nMax
			self.tDividers[i] = Apollo.LoadForm(self.xmlDoc, "DividerTemp", self.wndCastFrame:FindChild("CastBar"), self)
			self.tDividers[i]:SetAnchorPoints(nLeft, 0, nRight, 1)
			self.tDividers[i]:SetAnchorOffsets(0,0,0,0)
			self.tDividers[i]:Show(true);
			self.tDividers[i]:SetOpacity(0.5)
			self.tDividers[i]:SetBGColor("vdarkgray")
			--self.tDividersTap[i]:SetSprite(self.Settings.playerBar.sTexture)
		end
	
	
	elseif self.tCurrentOpSpell.eCastMethod == Spell.CodeEnumCastMethod.RapidTap then
		local wndBar = self.wndCastFrame:FindChild("CastBar")
		if self.Settings.specialBar.bEnabled then
			wndBar = self.wndSpecialCastFrame:FindChild("CastBar")
		end
		local nLeft = 0
		local nRight = 1
		local nMax = self.tCurrentOpSpell.nMaxTier
		self.tCurrentOpSpellTap = self:CopyTable(self.tCurrentOpSpell)
		
		if self.tDividersTap ~= nil then
			for i, wnd in pairs(self.tDividersTap) do
				self.tDividersTap[i]:Destroy()
			end
			self.tDividersTap = nil
		end
		
		self.tDividersTap = {}
		for i = 1, nMax do
			nLeft = (i-1)/nMax
			nRight = i/nMax
			self.tDividersTap[i] = Apollo.LoadForm(self.xmlDoc, "DividerTemp", wndBar, self)
			self.tDividersTap[i]:SetAnchorPoints(nLeft, 0, nRight, 1)
			self.tDividersTap[i]:SetAnchorOffsets(0,0,0,0)
			self.tDividersTap[i]:Show(true);
			self.tDividersTap[i]:SetOpacity(0.5)
			self.tDividersTap[i]:SetBGColor(self.Settings.specialBar.clrBarColor)
			self.tDividersTap[i]:SetSprite(self.Settings.specialBar.sTexture)
			--Apollo.StartTimer("ClearDividerTimer",self.tCurrentOpSpell.fDuration,false )
			
		end

	end
	


	-- Do the initial update so the first tier is lit up correctly
	self:OnUpdateSpellThreshold(idSpell, self.tCurrentOpSpell.nCurrentTier)
end

function SCastBar:OnUpdateSpellThreshold(idSpell, nNewThreshold) -- Updates when P/H/R changes tier or RT tap is performed
	if (self.tCurrentOpSpell == nil or idSpell ~= self.tCurrentOpSpell.id) and (self.tCurrentOpSpellTap == nil or idSpell ~= self.tCurrentOpSpellTap.id) then return end
	local myOpSpell = nil
	if self.tCurrentOpSpell ~= nil then
		self.tCurrentOpSpell.nCurrentTier = nNewThreshold
		myOpSpell = self.tCurrentOpSpell
	end
	if self.tCurrentOpSpellTap ~= nil and idSpell == self.tCurrentOpSpellTap.id then
		self.tCurrentOpSpellTap.nCurrentTier = nNewThreshold
		myOpSpell = self.tCurrentOpSpellTap
	end
	if (myOpSpell.eCastMethod == Spell.CodeEnumCastMethod.PressHold or myOpSpell.eCastMethod == Spell.CodeEnumCastMethod.ChargeRelease) then
		if myOpSpell.nCurrentTier > 1 then	
			--self.tDividers[i]:SetOpacity(fOpacity)
			self.tDividers[myOpSpell.nCurrentTier - 1]:SetBGColor("xkcdLimeGreen")
		end
	elseif myOpSpell.eCastMethod == Spell.CodeEnumCastMethod.RapidTap  then
		--tapstuff
		
		--self.tDividers[i]:SetOpacity(fOpacity)
		self.tDividersTap[myOpSpell.nMaxTier - myOpSpell.nCurrentTier+1]:SetBGColor("vdarkgray")

	end 
end

function SCastBar:OnClearSpellThreshold(idSpell)

	if self.tCurrentOpSpell ~= nil and idSpell ~= self.tCurrentOpSpell.id then 
		if (self.tCurrentOpSpellTap ~= nil and idSpell ~= self.tCurrentOpSpellTap.id) or self.tCurrentOpSpellTap == nil then
			return -- different spell got loaded up before the previous was cleared. this is valid.
		end 
	end
	
	local myOpSpell = nil
	if self.tCurrentOpSpell ~= nil and idSpell ==  self.tCurrentOpSpell.id then
		myOpSpell = self.tCurrentOpSpell
	elseif self.tCurrentOpSpellTap ~= nil and idSpell ==  self.tCurrentOpSpellTap.id  then
		myOpSpell = self.tCurrentOpSpellTap
	end
	if myOpSpell == nil then
		return
	end

	
	if myOpSpell.eCastMethod == Spell.CodeEnumCastMethod.RapidTap then
		local wndBar
		if self.Settings.specialBar.bEnabled then
			wndBar = self.wndSpecialCastFrame:FindChild("TapBar")
		else
			wndBar = self.wndCastFrame:FindChild("TapBar")
		end
		wndBar:SetProgress(0)
		
		if self.tDividersTap~= nil then
			for i, wnd in pairs(self.tDividersTap) do
				self.tDividersTap[i]:Destroy()
			end
			self.tDividersTap = nil
		end
		if self.tCurrentOpSpell~= nil and self.tCurrentOpSpell.id == self.tCurrentOpSpellTap.id then
			self.tCurrentOpSpell = nil
		end

		self.tCurrentOpSpellTap = nil
		
	else 
		if self.tDividers ~= nil then
			for i, wnd in pairs(self.tDividers) do
				self.tDividers[i]:Destroy()
			end
			self.tDividers = nil
		end
		self.tCurrentOpSpell = nil
	end

	--self.tCurrentOpSpell = nil
	--self.tDividers = nil
end
	
function SCastBar:DrawSingleBarFrameTiered(wnd)
	local fPercentDone = GameLib.GetSpellThresholdTimePrcntDone(self.tCurrentOpSpell.id)
	wnd:FindChild("CastBar"):SetMax(1)

	if self.tCurrentOpSpell.nCurrentTier == self.tCurrentOpSpell.nMaxTier then
		wnd:FindChild("CastBar"):SetProgress(.99) -- last tier would read as empty; this fixes it
	else
		wnd:FindChild("CastBar"):SetProgress(fPercentDone)
	end

end

function SCastBar:OnClearDivider()
	if self.tDividers ~= nil then
		for i, wnd in pairs(self.tDividersTap) do
			self.tDividersTap[i]:Destroy()
		end
		self.tDividersTap = nil
	end
	Apollo.StopTimer("ClearDividerTimer")
end
	
function SCastBar:HideCastIcons(wnd, sIcon, bHide)
	local nWidthSpell = wnd:FindChild("SpellIcon"):GetWidth()
	local nWidthInterrupt = wnd:FindChild("InterruptIcon"):GetWidth()
		
	wnd:FindChild(sIcon):Show((not bHide))
	
	
	local bSpell = wnd:FindChild("SpellIcon"):IsVisible()
	local bInterrupt = wnd:FindChild("InterruptIcon"):IsVisible()
	
	if not bSpell then
		nWidthSpell = 0
	end
	if not bInterrupt then
		nWidthInterrupt = 0
	end


	wnd:FindChild("CastBar"):SetAnchorOffsets(nWidthSpell+4,4,-4 -nWidthInterrupt,-4)
	wnd:FindChild("TapBar"):SetAnchorOffsets(nWidthSpell+4,-4,-4 -nWidthInterrupt,-4)

end


function SCastBar:OnTutorial_RequestUIAnchor(eAnchor, idTutorial, strPopupText)
	if eAnchor == GameLib.CodeEnumTutorialAnchor.BuffFrame then
		local tRect = {}
		--tRect.l, tRect.t, tRect.r, tRect.b = self.wndBeneBuffBar:GetRect()
		--Event_FireGenericEvent("Tutorial_RequestUIAnchorResponse", eAnchor, idTutorial, strPopupText, tRect)
	end
end






function SCastBar:OnSave(eLevel)
   if eLevel == GameLib.CodeEnumAddonSaveLevel.Account then
        local tSave = {}
		self.Settings.playerBar.left, 			self.Settings.playerBar.top, 		self.Settings.playerBar.right,				self.Settings.playerBar.bottom 		= self.wndCastFrame:GetAnchorOffsets()
		self.Settings.specialBar.left, 			self.Settings.specialBar.top, 		self.Settings.specialBar.right,				self.Settings.specialBar.bottom 	= self.wndSpecialCastFrame:GetAnchorOffsets()
		self.Settings.targetBar.left,			self.Settings.targetBar.top,		self.Settings.targetBar.right,				self.Settings.targetBar.bottom 		= self.wndTargetCastFrame:GetAnchorOffsets()
		self.Settings.targetTargetBar.left,		self.Settings.targetTargetBar.top,	self.Settings.targetTargetBar.right,		self.Settings.targetTargetBar.bottom 	= self.wndTargetTargetCastFrame:GetAnchorOffsets()
		self.Settings.focusBar.left,			self.Settings.focusBar.top,			self.Settings.focusBar.right,				self.Settings.focusBar.bottom 		= self.wndFocusCastFrame:GetAnchorOffsets()
		self.Settings.focusTargetBar.left,		self.Settings.focusTargetBar.top,	self.Settings.focusTargetBar.right,			self.Settings.focusTargetBar.bottom 	= self.wndFocusTargetCastFrame:GetAnchorOffsets()
		self.Settings.clusterBarContainer.left,	self.Settings.clusterBarContainer.top,	self.Settings.clusterBarContainer.right,self.Settings.clusterBarContainer.bottom 	= self.wndClusterContainer:GetAnchorOffsets()
	

		self.arProfiles[self.curProfile] = self:CopyTable(self.Settings)
		tSave.arProfiles = self.arProfiles
		tSave.tRealmCharacter = self.tRealmCharacter
    	return self:CopyTable(tSave)
	end

	
end


function SCastBar:OnRestore(eLevel, tData)
	
	if eLevel == GameLib.CodeEnumAddonSaveLevel.Account then
		self.bRestored = true
		if tData.arProfiles == nil or tData.arProfiles.Default == nil then
			return
		end

		SCastBar.arProfiles = self:CopyTable(tData.arProfiles)
		SCastBar.tRealmCharacter = self:CopyTable(tData.tRealmCharacter)
		for k,v in pairs(SCastBar.arProfiles) do
			if (v.version ~= defaultSettings.version and defaultSettings.bNewSaveData) or v.bNewSaveData == nil then
				SCastBar.arProfiles[k] = self:CopyTable(defaultSettings)
				Print("SCastBar - New Version of SCastBar. Profile: '"..k.."' has been reset.")
			end
		end
		
		
		
		if self.bCharacterCreated then
			self:LoadProfile()
			SCastBar.Settings = self:CopyTable(self.arProfiles[self.curProfile])
		end
	
		
		return
	end
	
end



function SCastBar:ApplySettingsAll()
	self:ApplySettings(self.wndCastFrame, "playerBar", self:CopyTable(self.Settings))
	self:ApplySettings(self.wndSpecialCastFrame, "specialBar", self:CopyTable(self.Settings))
	self:ApplySettings(self.wndTargetCastFrame, "targetBar", self:CopyTable(self.Settings))
	self:ApplySettings(self.wndTargetTargetCastFrame, "targetTargetBar", self:CopyTable(self.Settings))
	self:ApplySettings(self.wndFocusCastFrame, "focusBar", self:CopyTable(self.Settings))
	self:ApplySettings(self.wndFocusTargetCastFrame, "focusTargetBar", self:CopyTable(self.Settings))
	self:ApplySettings(self.wndClusterContainer, "clusterBarContainer", self:CopyTable(self.Settings))

	self.wndClusterContainer:FindChild("Backdrop"):Show(self.Settings.bEditMode and self.Settings.clusterBar.bEnabled)
	self:SetGrowDirectionUp(self.wndClusterContainer,self.Settings["clusterBarContainer"].bGrowUpwards)
	if true then return end
end


function SCastBar:ApplySettings(wnd, sUnit, tSettings)
	if wnd == nil then

		wnd = self.wndCastFrame
	end
	
	if sUnit == nil then
		sUnit = "playerBar"

	end

	if wnd == nil then
		self.bNotLoaded = true
		return
	elseif self.bNotLoaded == true
		then self.bNotLoaded = false
	end

	if bDebug then
		self:CPrint("ApplySettings")
	end
	if self.Settings == nil then
		self.Settings = self:CopyTable(tSettings)
		--Print("HACK")
	end		
		


	
	wnd:SetAnchorPoints(0.5, 0.5, 0.5, 0.5)
	wnd:SetAnchorOffsets(tSettings[sUnit].left,tSettings[sUnit].top,tSettings[sUnit].right,tSettings[sUnit].bottom)
	wnd:Show(true, true)

	if tSettings.bLocked == true then
		
		wnd:RemoveStyle("Moveable")
		wnd:RemoveStyle("Sizable")
		wnd:AddStyle("IgnoreMouse")
	elseif tSettings.bLocked == false then		
		wnd:RemoveStyle("IgnoreMouse")
		wnd:AddStyle("Moveable")
		wnd:AddStyle("Sizable")
		
	end
	
	
	--texture
	wnd:FindChild("CastBar"):SetEmptySprite(tSettings[sUnit].sTexture)
	wnd:FindChild("CastBar"):SetFillSprite(tSettings[sUnit].sTexture)
	wnd:FindChild("CastBar"):SetBarColor(tSettings[sUnit].clrBarColor)
	
	wnd:FindChild("CastBar"):FindChild("Latency"):SetFillSprite(tSettings[sUnit].sTexture)
	wnd:FindChild("TapBar"):SetFillSprite(tSettings[sUnit].sTexture)	
	
	--stringcolor
	wnd:FindChild("CastBar"):FindChild("SpellName"):SetTextColor(tSettings[sUnit].clrTextColor)
	wnd:FindChild("CastBar"):FindChild("CastTime"):SetTextColor(tSettings[sUnit].clrTextColor)
	
	
	

	if bDebug then
		self:CPrint("ApplySettings DONE")
	end
end

function SCastBar:GetAbilitiesList()
	if self.abilitiesList == nil then
		self.abilitiesList = AbilityBook.GetAbilitiesList()
	end
	return self.abilitiesList
end


function SCastBar:GetSpellIconByName(spellName)
	local abilities = self:GetAbilitiesList()
	if abilities ~= nil then
		for _, ability in pairs(abilities) do
			if ability.strName == spellName then
				return ability.tTiers[1].splObject:GetIcon()
			end
		end
	end
	return ""
end




-----------------------------------------------------------------------------------------------
-- SCastBar Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/scast"
function SCastBar:OnSCastBarOn()
	--self:ApplySettings(self.wndCastFrame, self.Settings)
	self.wndConfig:Show(true) -- show the window
end


-----------------------------------------------------------------------------------------------
-- SCastBarConfig Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function SCastBar:OnOK()
	
	self.Settings.bEditMode = false
	self:SettingsSave()
	self:ApplySettingsAll()

	self.wndConfig:Show(false) -- hide the window
end

-- when the Cancel button is clicked
function SCastBar:OnCancel()
	
	--self.Settings = self.SettingsOld
	--self.curProfile = self.ProfileOld
	
	self.Settings.bEditMode = false
	self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"):SetCheck(false)
	self:OnConfigEditToggle(self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"), self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"))

	--self:ApplySettingsAll()
	
	self.wndConfig:Show(false)
end


function SCastBar:OnConfigResetClick( wndHandler, wndControl, eMouseButton )
	self.arProfiles[self.curProfile] = self:CopyTable(defaultSettings)
	self.Settings = self:CopyTable(defaultSettings)
	self:ApplySettingsAll()
	self:OnSave(GameLib.CodeEnumAddonSaveLevel.Account)

	Print("SCastBar - Profile: '"..self.curProfile.."' has been reset.")
	self:OnConfigShow(self.wndConfig, self.wndConfig)

end

function SCastBar:OnConfigLockToggle( wndHandler, wndControl, eMouseButton )
	if wndHandler ~= wndControl then return end
  	self.Settings.bLocked = wndControl:IsChecked()
	self:OnSave(GameLib.CodeEnumAddonSaveLevel.Account)
	self:ApplySettingsAll()


end

function SCastBar:OnConfigEditToggle( wndHandler, wndControl, eMouseButton )
	if wndHandler ~= wndControl then return end
  	self.Settings.bEditMode = wndControl:IsChecked()
	--self:SettingsSave()
	self:OnSave(GameLib.CodeEnumAddonSaveLevel.Account)
	self:ApplySettingsAll()

	if wndControl:IsChecked() then
		self.wndCastFrame:FindChild("CastBar"):FindChild("SpellName"):SetText("Player")
		self.wndSpecialCastFrame:FindChild("CastBar"):FindChild("SpellName"):SetText("Special Castbar")
		self.wndTargetCastFrame:FindChild("CastBar"):FindChild("SpellName"):SetText("Target")
		self.wndTargetTargetCastFrame:FindChild("CastBar"):FindChild("SpellName"):SetText("Target of Target")
		self.wndFocusCastFrame:FindChild("CastBar"):FindChild("SpellName"):SetText("Focus")
		self.wndFocusTargetCastFrame:FindChild("CastBar"):FindChild("SpellName"):SetText("Target of Focus")
		
	end



end

function SCastBar:OnConfigShow( wndHandler, wndControl )
	if wndHandler ~= wndControl then return end
	self:SettingsLoad()
	
	self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"):SetCheck(true)
	self:OnConfigEditToggle(self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"), self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"))

end



---------------------------------------------------------------------------------------------------
-- Settings Functions
---------------------------------------------------------------------------------------------------


function SCastBar:SettingsLoad()
		local tSettings = SCastBar:CopyTable(self.Settings)
		
		--GENERAL
		
		local wndSettings = self.wndSettings_Profiles
		
		wndSettings:FindChild("profilesGeneral"):FindChild("CurrentProfile"):FindChild("EditBox"):SetText(self.curProfile)
		wndSettings:FindChild("profilesGeneral"):FindChild("SaveProfileAs"):FindChild("EditBox"):SetText(self.curProfile)
		wndSettings:FindChild("profilesGeneral"):FindChild("LoadProfile"):FindChild("ComboBox"):DeleteAll()
		for k, v in pairs(self.arProfiles) do
			wndSettings:FindChild("profilesGeneral"):FindChild("LoadProfile"):FindChild("ComboBox"):AddItem(k)
		end
		wndSettings:FindChild("profilesGeneral"):FindChild("LoadProfile"):FindChild("TextBG"):FindChild("ComboBox"):SetText(self.curProfile)
	
		
		--PLAYER
		wndSettings = self.wndSettings_Player
		local sBar = "player"

		wndSettings:FindChild(sBar.."General"):FindChild("btnEnabled"):SetCheck(tSettings[sBar.."Bar"].bEnabled)
		wndSettings:FindChild(sBar.."Style"):FindChild("Overlay"):Show(not tSettings[sBar.."Bar"].bEnabled)
		wndSettings:FindChild(sBar.."Style"):FindChild("btnIcon"):SetCheck(tSettings[sBar.."Bar"].bShowIcon)
		wndSettings:FindChild(sBar.."Style"):FindChild("btnCastTime"):SetCheck(tSettings[sBar.."Bar"].bCastTime)
		wndSettings:FindChild(sBar.."Style"):FindChild("btnLatency"):SetCheck(tSettings[sBar.."Bar"].bLatency)
		
		wndSettings:FindChild(sBar.."Style"):FindChild("BarColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetBGColor(tSettings[sBar.."Bar"].clrBarColor)
		wndSettings:FindChild(sBar.."Style"):FindChild("TextColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetBGColor(tSettings[sBar.."Bar"].clrTextColor)
		wndSettings:FindChild(sBar.."Style"):FindChild("Texture"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetBGColor(tSettings[sBar.."Bar"].clrBarColor)
		wndSettings:FindChild(sBar.."Style"):FindChild("Texture"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetSprite(tSettings[sBar.."Bar"].sTexture)
		
		--SPECIALBAR
		sBar = "special"
		--local bTest = not tSettings[sBar.."Bar"].bEnabled
		wndSettings:FindChild(sBar.."General"):FindChild("btnEnabled"):SetCheck(tSettings[sBar.."Bar"].bEnabled)
		wndSettings:FindChild(sBar.."Style"):FindChild("Overlay"):Show(not tSettings[sBar.."Bar"].bEnabled)
		wndSettings:FindChild(sBar.."Style"):FindChild("BarColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetBGColor(tSettings[sBar.."Bar"].clrBarColor)
		wndSettings:FindChild(sBar.."Style"):FindChild("TextColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetBGColor(tSettings[sBar.."Bar"].clrTextColor)
		wndSettings:FindChild(sBar.."Style"):FindChild("Texture"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetBGColor(tSettings[sBar.."Bar"].clrBarColor)
		wndSettings:FindChild(sBar.."Style"):FindChild("Texture"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetSprite(tSettings[sBar.."Bar"].sTexture)
		
		
		--TARGET, TARGETTARGET, FOCUS, FOCUSTARGET
		local tHelper = { 
			target = self.wndSettings_Target, 
			targetTarget = self.wndSettings_Target,
			focus = self.wndSettings_Focus,
			focusTarget = self.wndSettings_Focus,
			cluster = self.wndSettings_Cluster
		}
		
		for sBar, wndSettings in pairs(tHelper) do
			wndSettings:FindChild(sBar.."General"):FindChild("btnEnabled"):SetCheck(tSettings[sBar.."Bar"].bEnabled)
			wndSettings:FindChild(sBar.."Style"):FindChild("Overlay"):Show(not tSettings[sBar.."Bar"].bEnabled)
			wndSettings:FindChild(sBar.."Style"):FindChild("btnCastTime"):SetCheck(tSettings[sBar.."Bar"].bCastTime)
			wndSettings:FindChild(sBar.."Style"):FindChild("btnLatency"):SetCheck(tSettings[sBar.."Bar"].bLatency)
			wndSettings:FindChild(sBar.."Style"):FindChild("btnInterruptArmor"):SetCheck(tSettings[sBar.."Bar"].bCCArmor)
			
			wndSettings:FindChild(sBar.."Style"):FindChild("Texture"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetBGColor(tSettings[sBar.."Bar"].clrBarColor)
			wndSettings:FindChild(sBar.."Style"):FindChild("Texture"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetSprite(tSettings[sBar.."Bar"].sTexture)
			wndSettings:FindChild(sBar.."Style"):FindChild("TextColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetBGColor(tSettings[sBar.."Bar"].clrTextColor)
			
			wndSettings:FindChild(sBar.."Style"):FindChild("btnHostility"):SetCheck(tSettings[sBar.."Bar"].bColorByHostility)
			wndSettings:FindChild(sBar.."Style"):FindChild("btnCustomColor"):SetCheck((not tSettings[sBar.."Bar"].bColorByHostility))
			
			wndSettings:FindChild(sBar.."Style"):FindChild("BarColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):SetBGColor(tSettings[sBar.."Bar"].clrBarColor)
		end	
			
		self.wndSettings_Cluster:FindChild("clusterStyle"):FindChild("btnGrowUpwards"):SetCheck(tSettings["clusterBarContainer"].bGrowUpwards)	

		
			
		
		--EDITMODE
		
		self.wndConfig:FindChild("Window_EditMode"):FindChild("btnLock"):SetCheck(tSettings.bLocked)	
		--self:OnConfigEditToggle(self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"), self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"))

end

function SCastBar:SettingsSave()
		local tSettings = self:CopyTable(self.Settings)
		
		--GENERAL
		
		--nothing here?
		
		
		
		--PLAYER
		wndSettings = self.wndSettings_Player
		local sBar = "player"

		tSettings[sBar.."Bar"].bEnabled = wndSettings:FindChild(sBar.."General"):FindChild("btnEnabled"):IsChecked()
		tSettings[sBar.."Bar"].bShowIcon = wndSettings:FindChild(sBar.."Style"):FindChild("btnIcon"):IsChecked()
		tSettings[sBar.."Bar"].bCastTime = wndSettings:FindChild(sBar.."Style"):FindChild("btnCastTime"):IsChecked()
		tSettings[sBar.."Bar"].bLatency = wndSettings:FindChild(sBar.."Style"):FindChild("btnLatency"):IsChecked()
		
		tSettings[sBar.."Bar"].clrBarColor = self:ConvertColorToHex(wndSettings:FindChild(sBar.."Style"):FindChild("BarColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):GetBGColor())
		tSettings[sBar.."Bar"].clrTextColor = self:ConvertColorToHex(wndSettings:FindChild(sBar.."Style"):FindChild("TextColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):GetBGColor())
		tSettings[sBar.."Bar"].sTexture = wndSettings:FindChild(sBar.."Style"):FindChild("Texture"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):GetSprite()
				
		sBar = "special"
		tSettings[sBar.."Bar"].bEnabled =  wndSettings:FindChild(sBar.."General"):FindChild("btnEnabled"):IsChecked()
		tSettings[sBar.."Bar"].clrBarColor = self:ConvertColorToHex(wndSettings:FindChild(sBar.."Style"):FindChild("BarColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):GetBGColor())
		tSettings[sBar.."Bar"].clrTextColor = self:ConvertColorToHex(wndSettings:FindChild(sBar.."Style"):FindChild("TextColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):GetBGColor())
		tSettings[sBar.."Bar"].sTexture = wndSettings:FindChild(sBar.."Style"):FindChild("Texture"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):GetSprite()
		
		
		
		--TARGET, TARGETTARGET, FOCUS, FOCUSTARGET
		local tHelper = { 
			target = self.wndSettings_Target, 
			targetTarget = self.wndSettings_Target,
			focus = self.wndSettings_Focus,
			focusTarget = self.wndSettings_Focus,
			cluster = self.wndSettings_Cluster
		}
		
		for sBar, wndSettings in pairs(tHelper) do
			tSettings[sBar.."Bar"].bEnabled = wndSettings:FindChild(sBar.."General"):FindChild("btnEnabled"):IsChecked()
			tSettings[sBar.."Bar"].bCastTime = wndSettings:FindChild(sBar.."Style"):FindChild("btnCastTime"):IsChecked()
			tSettings[sBar.."Bar"].bLatency = wndSettings:FindChild(sBar.."Style"):FindChild("btnLatency"):IsChecked()
			tSettings[sBar.."Bar"].bCCArmor = wndSettings:FindChild(sBar.."Style"):FindChild("btnInterruptArmor"):IsChecked()
			
			tSettings[sBar.."Bar"].sTexture = wndSettings:FindChild(sBar.."Style"):FindChild("Texture"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):GetSprite()
			tSettings[sBar.."Bar"].clrTextColor = self:ConvertColorToHex(wndSettings:FindChild(sBar.."Style"):FindChild("TextColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):GetBGColor())
			
			tSettings[sBar.."Bar"].bColorByHostility = wndSettings:FindChild(sBar.."Style"):FindChild("btnHostility"):IsChecked()
			
			
			tSettings[sBar.."Bar"].clrBarColor = self:ConvertColorToHex(wndSettings:FindChild(sBar.."Style"):FindChild("BarColor"):FindChild("ColorSwatchBG"):FindChild("ColorSwatch"):GetBGColor())
		end	
					
		tSettings["clusterBarContainer"].bGrowUpwards = self.wndSettings_Cluster:FindChild("clusterStyle"):FindChild("btnGrowUpwards"):IsChecked()
		
		
		--EDITMODE
		--tSettings.bEditMode = self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"):IsChecked()
		tSettings.bLocked = self.wndConfig:FindChild("Window_EditMode"):FindChild("btnLock"):IsChecked()	
		--self:OnConfigEditToggle(self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"), self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"))
		
		self.Settings = self:CopyTable(tSettings)
		self.arProfiles[self.curProfile] = self:CopyTable(tSettings)
		self:OnSave(GameLib.CodeEnumAddonSaveLevel.Account)

		
end




---------------------------------------------------------------------------------------------------
-- SCastBarConfigNEU Functions
---------------------------------------------------------------------------------------------------

function SCastBar:OnMenuTreeButtonClick( wndHandler, wndControl, eMouseButton )
	--local sClickTarget = 
	-- Hide all Settings frames
	self.wndSettings_Profiles:Show(false)
	self.wndSettings_Player:Show(false)
	self.wndSettings_Target:Show(false)
	self.wndSettings_Focus:Show(false)
	self.wndSettings_Cluster:Show(false)
	
	-- show the corresponding settings frame
	local wnd =	self["wndSettings_"..string.sub(wndHandler:GetName(),4)]
	wnd:Show(true)
	self.wndConfig:FindChild("SettingsFrame"):SetVScrollPos(0)
	
end


function SCastBar:OnEnableButtonClick( wndHandler, wndControl, eMouseButton )
	if wndControl ~= wndHandler then return end
	local bEn = wndControl:IsChecked()
	
	local sParent = wndHandler:GetParent():GetName()
	local nLen = string.len(sParent)
	local sClickTarget = string.sub(sParent,1,nLen-7)

	self.Settings[sClickTarget.."Bar"].bEnabled = bEn
	
	wndControl:GetParent():GetParent():FindChild(sClickTarget.."Style"):FindChild("Overlay"):Show((not bEn))
	--wndHandler:GetParent():GetParent():FindChild(wndHandler.sClickTarget.."Style"):FindChild("Overlay"):SetOpacity(0.5)
	
	
	
	self:OnConfigEditToggle(self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"), self.wndConfig:FindChild("Window_EditMode"):FindChild("btnEditMode"))
end




---------------------------------------------------------------------------------------------------
-- SCastBarContainer Functions
---------------------------------------------------------------------------------------------------



function SCastBar:OnCastBarResize( wndHandler, wndControl )
	local nHeightSpell =	self.wndCastFrame:FindChild("SpellIcon"):GetHeight()
	local nWidthSpell =  self.wndCastFrame:FindChild("SpellIcon"):GetWidth()	
	if nHeightSpell ~= nWidthSpell then
		local nLeft, nTop, nRight, nBottom = self.wndCastFrame:FindChild("SpellIcon"):GetAnchorOffsets()	
		local nNew = nHeightSpell+4

		wndHandler:FindChild("SpellIcon"):SetAnchorOffsets(nLeft, nTop,nNew,nBottom)
		self.wndCastFrame:FindChild("CastBar"):SetAnchorOffsets(nNew,nTop,nRight,nBottom)
		self.wndCastFrame:FindChild("TapBar"):SetAnchorOffsets(nNew,nTop,nRight,nBottom)
	end
	
	
	local nHeightInterrupt =	self.wndCastFrame:FindChild("InterruptIcon"):GetHeight()
	local nWidthInterrupt =  self.wndCastFrame:FindChild("InterruptIcon"):GetWidth()	
	if nHeightInterrupt ~= nWidthInterrupt then
		local nLeft, nTop, nRight, nBottom = self.wndCastFrame:FindChild("InterruptIcon"):GetAnchorOffsets()	
		local nNew = nHeightInterrupt+4

		wndHandler:FindChild("InterruptIcon"):SetAnchorOffsets(-nNew, nTop,nRight,nBottom)
		self.wndCastFrame:FindChild("CastBar"):SetAnchorOffsets(nLeft,nTop,-nNew,nBottom)
		self.wndCastFrame:FindChild("TapBar"):SetAnchorOffsets(nLeft,nTop,-nNew,nBottom)
	end

end





---------------------------------------------------------------------------------------------------
-- Settings_Player Functions
---------------------------------------------------------------------------------------------------



function SCastBar:OnBarColorButtonUp( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	if wndControl  ~= wndHandler then return end
	if ColorPicker then
		local strFrame = wndHandler:GetParent():GetName()
		local sBar = wndHandler:GetParent():GetParent():GetName()
		local nLen = string.len(sBar)
		sBar = string.sub(sBar,1, nLen-5)
		SCastBar.curCPColor = CColor.new(self:ConvertHexToColor(self.Settings[sBar.."Bar"]["clr"..strFrame]))
		ColorPicker.AdjustCColor(SCastBar.curCPColor, false, SCastBarUpdateColor, wndHandler)
	end 
end

function SCastBarUpdateColor(wndHandler)
	local strFrame = wndHandler:GetParent():GetName()
	local sBar = wndHandler:GetParent():GetParent():GetName()
	local nLen = string.len(sBar)
	sBar = string.sub(sBar,1, nLen-5)
	SCastBar.Settings[sBar.."Bar"]["clr"..strFrame] = SCastBar:ConvertColorToHex(SCastBar.curCPColor)
	wndHandler:FindChild("ColorSwatch"):SetBGColor(SCastBar:ConvertColorToHex(SCastBar.curCPColor))
end


---------------------------------------------------------------------------------------------------
-- Settings_Target Functions
---------------------------------------------------------------------------------------------------

function SCastBar:OnBarTextureButtonUp( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	if wndControl ~= wndHandler then return end

	if MediaShare then
		local curTexture = wndHandler:FindChild("ColorSwatch"):GetSprite()
		MediaShare.GetTexture(curTexture, SCastBarUpdateTexture,wndHandler:FindChild("ColorSwatch"))
	end
	
end

function SCastBarUpdateTexture(newTexture, wnd)
	if wnd == nil or newTexture == nil then return end
	wnd:SetSprite(newTexture)
end


---------------------------------------------------------------------------------------------------
-- Settings_General Functions
---------------------------------------------------------------------------------------------------



function SCastBar:OnSaveProfilesAs( wndHandler, wndControl, strText )
	if strText == nil or strText == "" then
		Print("No valid Profile-Name")
		return
	
	end
	if self.arProfiles[strText] ~= nil then
	
		-- ask to overwrite?
		Print("Overwriting Profile: "..strText)
	else 
		self.arProfiles[strText] = {}
	end
	self:SetProfile(strText)
	self:SettingsSave()
	self:ApplySettingsAll()
	self:OnConfigShow(self.wndConfig, self.wndConfig)
	
end

---------------------------------------------------------------------------------------------------
-- Settings_Profiles Functions
---------------------------------------------------------------------------------------------------
function SCastBar:SetProfile(strProfile)
	self.curProfile = strProfile
	local tTemp =  GameLib.GetAccountRealmCharacter()
	if self.tRealmCharacter[tTemp.strRealm] == nil then
		self.tRealmCharacter[tTemp.strRealm] = {}
	end
	self.tRealmCharacter[tTemp.strRealm][tTemp.strCharacter] = strProfile
	
end




function SCastBar:LoadProfile()
	if GameLib.GetPlayerUnit() == nil then return end
	
	local strProfile = "Default"
	local tTemp =  GameLib.GetAccountRealmCharacter()

	if self.tRealmCharacter[tTemp.strRealm] == nil or self.tRealmCharacter[tTemp.strRealm][tTemp.strCharacter] == nil then
		--Print("SCastBar - No profile found for '"..tTemp.strCharacter.."' on '"..tTemp.strRealm.."'. Setting profile to 'Default'")
		self:SetProfile("Default")		
	else
		strProfile = self.tRealmCharacter[tTemp.strRealm][tTemp.strCharacter]
		--Print("SCastBar - profile for this Character: '"..strProfile.."'")
		if self.arProfiles[strProfile] == nil then
			strProfile = "Default"
			
		end
	end
	
	self.curProfile = strProfile
	
end

function SCastBar:OnLoadProfileChanged( wndHandler, wndControl )
	if wndHandler ~= wndControl then return end
	local strProfile = wndHandler:GetSelectedText()
	if strProfile == nil or strProfile == "" or self.arProfiles[strProfile] == nil then
		Print("No valid Profile-Name: "..strProfile)
		return
	end
	self.Settings = self:CopyTable(self.arProfiles[strProfile])
	self:SetProfile(strProfile)
	
	
	self:SettingsLoad()
	self:SettingsSave()
	self:ApplySettingsAll()
	self:OnConfigShow(self.wndConfig, self.wndConfig)
	--self.wndSettings_Profiles:FindChild("profilesGeneral"):FindChild("LoadProfile"):FindChild("TextBG"):FindChild("ComboBox"):SetText(strProfile)

end

function SCastBar:OnDeleteProfileButtonUp( wndHandler, wndControl, eMouseButton )
	local strProfile = self.wndSettings_Profiles:FindChild("profilesGeneral"):FindChild("CurrentProfile"):FindChild("EditBox"):GetText()
	if strProfile ~= self.curProfile then
		Print("A stange error occured while deleting: "..strProfile)
		return
	
	elseif strProfile == "Default" then
		Print("You cannot delete the Default Profile. Try resetting instead.")
		return
		
	else
		self.arProfiles[strProfile] = nil
		self.wndSettings_Profiles:FindChild("profilesGeneral"):FindChild("LoadProfile"):FindChild("ComboBox"):DeleteAll()
		self:SetProfile("Default")
		self.Settings = self:CopyTable(defaultSettings)
		self:SettingsSave()

		self:OnConfigShow(self.wndConfig, self.wndConfig)
		self:ApplySettingsAll()
	end
	
	
end

function SCastBar:OnSettings_ProfileShow( wndHandler, wndControl )
	wndHandler:FindChild("profilesGeneral"):FindChild("CurrentProfile"):FindChild("EditBox"):SetText(self.curProfile)
	wndHandler:FindChild("profilesGeneral"):FindChild("SaveProfileAs"):FindChild("EditBox"):SetText(self.curProfile)

end

---------------------------------------------------------------------------------------------------
-- Settings_Cluster Functions
---------------------------------------------------------------------------------------------------

function SCastBar:OnSettings_ClusterGrowUpwardsCheck( wndHandler, wndControl, eMouseButton )
	if wndHandler~= wndControl then return end
	self:SetGrowDirectionUp(self.wndClusterContainer, wndHandler:IsChecked())
end


function SCastBar:SetGrowDirectionUp(wndContainer, bUp)
	local a,b,c
	local nBar = 1
	local wnd
	if bUp then
		a = 5
		b = 1
		c = -1
		--	Print("Direction: UP ")
	else
		a = 1
		b = 5
		c = 1
		--Print("Direction: Down ")
	end
	
	
	for i = a, b, c do
		wnd = self["wndClusterBar"..nBar]
		wnd:SetAnchorPoints(0, (i-1)*0.2, 1, i*0.2)
		wnd:SetAnchorOffsets(0, 0, 0,0 )
		nBar = nBar + 1
	
	end
end


function SCastBar:ConvertColorToHex(color)
	return string.format("%02x%02x%02x%02x", self:Round(255 * color.a), self:Round(255 * color.r), self:Round(255 * color.g), self:Round(255 * color.b))
end

function SCastBar:ConvertHexToColor(hex)
	local a = string.sub(hex, 1, 2)
	hex = string.sub(hex, -6)
	local r, g, b = 0, 0, 0
	local n = tonumber(hex, 16)
	if n then
		r = math.floor(n / 65536)
		g = math.floor((n / 256) % 256)
		b = n % 256
	end
	return r / 255, g / 255, b / 255, 1
end

function SCastBar:Round(n, nDecimals, bForceDecimals)
	local nMult = 1
	if nDecimals and nDecimals > 0 then
		for i = 1, nDecimals do nMult = nMult * 10 end
	end
	n = math.floor((n * nMult) + 0.5) / nMult
	if bForceDecimals then n = string.format("%." .. nDecimals .. "f", n) end
	return n
end

function SCastBar:CopyTable(t)
	local o = {}

	for k,v in pairs(t) do
		if type(v) == 'table' then
			o[k] = self:CopyTable(v)
		else
			o[k] = v
		end
	end

	return o
end

function SCastBar:PrintTable(t, n)
	if t == nil then return	end
	if n == nil then n = 0 end
	local space =""
	if n > 0 then
		for i = 1, n do
			space = space.."  "
		end
	end
	for k,v in pairs(t)do
		if type(v) == 'table' then
			Print(space..tostring(k)..": ")
			self:PrintTable(v,n+1)
			
		else
			Print(space.."("..type(v).."): "..tostring(k).." >> " .. tostring(v))
		end
	end
	

end



-----------------------------------------------------------------------------------------------
-- SCastBar Instance
-----------------------------------------------------------------------------------------------
local SCastBarInst = SCastBar:new()
SCastBarInst:Init()
